;CodeVisionAVR C Compiler V1.0.0.8v Evaluation
;(C) Copyright 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;http://infotech.ir.ro
;e-mail:dhptechn@ir.ro , hpinfotech@mail.com

;Chip type        : AT90S2313
;Clock frequency  : 10,000000 MHz
;Memory model     : Tiny
;Internal RAM size: 128
;External RAM size: 0
;Data Stack size  : 32
;Automatic register allocation: On
;Use AVR Studio Terminal I/O  : No

	.DEVICE AT90S2313
	.LISTMAC
	.EQU UDRE=5
	.EQU RXC=7
	.EQU UBRR=9
	.EQU UCR=0xA
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0
	.EQU EEWE=1
	.EQU EEMWE=2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __EQB10
	TST  R30
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB10
	CPI  R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB10
	CLR  R0
	CP   R0,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB10
	CLR  R0
	CP   R0,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB10
	CPI  R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB10
	TST  R30
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW10
	SBIW R30,0
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW10
	SBIW R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW10
	RCALL __CPW01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW10
	RCALL __CPW01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW10
	SBIW R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW10
	SBIW R30,0
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD10
	RCALL __CPD10
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED10
	RCALL __CPD10
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD10
	RCALL __CPD01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED10
	RCALL __CPD01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD10
	RCALL __CPD10
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED10
	RCALL __CPD10
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB12J
	CP   R30,R26
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB12J
	CP   R30,R26
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12J
	CP   R30,R26
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12J
	CP   R26,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12J
	CP   R26,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12J
	CP   R30,R26
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12UJ
	CP   R30,R26
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12UJ
	CP   R26,R30
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12UJ
	CP   R26,R30
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12UJ
	CP   R30,R26
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW12J
	CP   R30,R26
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW12J
	CP   R30,R26
	CPC  R31,R27
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12J
	CP   R30,R26
	CPC  R31,R27
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12J
	CP   R26,R30
	CPC  R27,R31
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12J
	CP   R26,R30
	CPC  R27,R31
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12J
	CP   R30,R26
	CPC  R31,R27
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD12J
	RCALL __CPD12
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED12J
	RCALL __CPD12
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12J
	RCALL __CPD12
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12J
	RCALL __CPD21
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12J
	RCALL __CPD21
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12J
	RCALL __CPD12
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12UJ
	RCALL __CPD12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12UJ
	RCALL __CPD21
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12UJ
	RCALL __CPD21
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12UJ
	RCALL __CPD12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCS __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCC __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCS __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCC __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB1NJ
	CPI  R30,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB1NJ
	CPI  R30,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB2NJ
	CPI  R26,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB2NJ
	CPI  R26,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NJ
	CPI  R26,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NJ
	CPI  R26,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NUJ
	CPI  R26,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NUJ
	CPI  R26,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __BITSREG0
	BRBC @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __BITSREG1
	BRBS @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBR0
	TST  R@0
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR0
	TST  R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR0
	CLR  R0
	CP   R0,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR0
	CLR  R0
	CP   R0,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR0
	TST  R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBR0
	TST  R@0
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBRRJ
	CP   R@0,R@1
	BREQ __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __NEBRRJ
	CP   R@0,R@1
	BRNE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRJ
	CP   R@0,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRJ
	CP   R@1,R@0
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRJ
	CP   R@1,R@0
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRJ
	CP   R@0,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRUJ
	CP   R@0,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRUJ
	CP   R@1,R@0
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRUJ
	CP   R@1,R@0
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRUJ
	CP   R@0,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __NEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEB1RJ
	CP   R30,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RJ
	CP   R@0,R30
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RJ
	CP   R@0,R30
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RJ
	CP   R30,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEB1RUJ
	CP   R30,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RUJ
	CP   R@0,R30
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RUJ
	CP   R@0,R30
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RUJ
	CP   R30,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2J
	CP   R@0,R26
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2J
	CP   R26,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2J
	CP   R26,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2J
	CP   R@0,R26
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2UJ
	CP   R@0,R26
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2UJ
	CP   R26,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2UJ
	CP   R26,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2UJ
	CP   R@0,R26
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQBRNJ
	CPI  R@0,LOW(@2)
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBRNJ
	CPI  R@0,LOW(@2)
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __TESTSREG
	LDI  R30,1
	BRBS @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __NTESTSREG
	LDI  R30,1
	BRBC @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.CSEG
	.ORG 0x0B

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;DISABLE WATCHDOG
	LDI  R30,0x18
	OUT  WDTCR,R30
	LDI  R30,0x10
	OUT  WDTCR,R30
	CLR  R30
	OUT  MCUCR,R30

;CLEAR R2-R15
	LDI  R24,14
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR RAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_RAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_RAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	MOV  R1,R0
	ADIW R30,1
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	MOV  R26,R0
	ADIW R30,1
	LPM
	MOV  R27,R0
	ADIW R30,1
	LPM
	MOV  R24,R0
	ADIW R30,1
	LPM
	MOV  R25,R0
	ADIW R30,1
__GLOBAL_INI_LOOP:
	LPM
	ST   X+,R0
	ADIW R30,1
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x7F)

	RJMP  _main

	.ESEG
	.ORG 1

	.DSEG
	.ORG 0x80
;       1 /***************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.0.0.8v Evaluation
;       4 Automatic Program Generator
;       5  Copyright 1998-2000
;       6 Pavel Haiduc, HP InfoTech S.R.L.
;       7 http://infotech.ir.ro
;       8 e-mail:dhptechn@ir.ro , hpinfotech@mail.com
;       9 
;      10 Project : 
;      11 Version : 
;      12 Date    : 06.11.2000
;      13 Author  : 
;      14 Company : 
;      15 Comments: 
;      16 
;      17 
;      18 Chip type        : AT90S2313
;      19 Clock frequency  : 10,000000 MHz
;      20 Memory model     : Tiny
;      21 Internal RAM size: 128
;      22 External RAM size: 0
;      23 Data Stack size  : 32
;      24 ***************************************/
;      25 
;      26 #include <90s2313.h>
;      27 // CodeVisionAVR C Compiler
;      28 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      29 
;      30 // I/O registers definitions for the AT90S2313
;      31 
;      32 #pragma used+
;      33 sfrb ACSR=8;
;      34 sfrb UBRR=9;
;      35 sfrb UCR=0xa;
;      36 sfrb USR=0xb;
;      37 sfrb UDR=0xc;
;      38 sfrb PIND=0x10;
;      39 sfrb DDRD=0x11;
;      40 sfrb PORTD=0x12;
;      41 sfrb PINB=0x16;
;      42 sfrb DDRB=0x17;
;      43 sfrb PORTB=0x18;
;      44 sfrb EECR=0x1c;
;      45 sfrb EEDR=0x1d;
;      46 sfrb EEAR=0x1e;
;      47 sfrb WDTCR=0x21;
;      48 sfrb ICR1L=0x24;
;      49 sfrb ICR1H=0x25;
;      50 sfrw ICR1=0x24;  // 16 bit access
;      51 sfrb OCR1L=0x2a;
;      52 sfrb OCR1H=0x2b;
;      53 sfrw OCR1=0x2a;  // 16 bit access
;      54 sfrb TCNT1L=0x2c;
;      55 sfrb TCNT1H=0x2d;
;      56 sfrw TCNT1=0x2c; // 16 bit access
;      57 sfrb TCCR1B=0x2e;
;      58 sfrb TCCR1A=0x2f;
;      59 sfrb TCNT0=0x32;
;      60 sfrb TCCR0=0x33;
;      61 sfrb MCUSR=0x34;
;      62 sfrb MCUCR=0x35;
;      63 sfrb TIFR=0x38;
;      64 sfrb TIMSK=0x39;
;      65 sfrb GIFR=0x3a;
;      66 sfrb GIMSK=0x3b;
;      67 sfrb SPL=0x3d;
;      68 sfrb SREG=0x3f;
;      69 #pragma used-
;      70 
;      71 #define OCR1AL OCR1L
;      72 #define OCR1AH OCR1H
;      73 
;      74 // Interrupt vectors definitions
;      75 
;      76 #define EXT_INT0 2
;      77 #define EXT_INT1 3
;      78 #define TIM1_CAPT 4
;      79 #define TIM1_COMP 5
;      80 #define TIM1_OVF 6
;      81 #define TIM0_OVF 7
;      82 #define UART_RXC 8
;      83 #define UART_DRE 9
;      84 #define UART_TXC 10
;      85 #define ANA_COMP 11
;      86 
;      87 
;      88 
;      89 // Standard Input/Output functions
;      90 #include <stdio.h>
;      91 // CodeVisionAVR C Compiler
;      92 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      93 
;      94 // Prototypes for standard I/O functions
;      95 
;      96 #pragma used+
;      97 
;      98 #pragma warn-
;      99 #ifndef _DEBUG_TERMINAL_IO_
;     100 #ifndef _ALTERNATE_GETCHAR_
;     101 char getchar(void)
;     102 {

	.CSEG
_getchar:
;     103 #asm
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
;     107 #endasm
;     108 }
	RET
;     109 #endif
;     110 
;     111 #ifndef _ALTERNATE_PUTCHAR_
;     112 void putchar(char c)
;     113 {
_putchar:
;     114 #asm
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
;     119 #endasm
;     120 }
	ADIW R28,1
	RET
;     121 #endif
;     122 #else
;     123 // Used for AVR Studio Terminal I/O
;     124 // DON'T CHANGE!
;     125 void getchar(void)
;     126 {
;     127 #asm
;     128      push  r16
;     129      push  r17
;     130 __getchar0:
;     131      rcall __c_getchar
;     132      cpi   r17,0xff
;     133      breq  __getchar0
;     134      mov   r30,r16
;     135      pop   r17
;     136      pop   r16
;     137 #endasm
;     138 }
;     139 
;     140 void putchar(char c)
;     141 {
;     142 #asm
;     143     mov   r30,r16
;     144     ld    r16,y
;     145     rcall __c_putchar
;     146     mov   r16,r30
;     147 #endasm
;     148 }
;     149 
;     150 void _c_getchar(void)
;     151 {
;     152 }
;     153 
;     154 void _c_putchar(void)
;     155 {
;     156 }
;     157 #endif
;     158 
;     159 #ifdef _WARNINGS_ON_
;     160 #pragma warn+
;     161 #endif
;     162 
;     163 void puts(char *str);
;     164 void putsf(char flash *str);
;     165 
;     166 #ifdef _MODEL_TINY_
;     167 char *gets(char *str,unsigned char len);
;     168 #endif
;     169 
;     170 #ifdef _MODEL_SMALL_
;     171 char *gets(char *str,unsigned int len);
;     172 #endif
;     173 
;     174 #pragma parptr+
;     175 void printf(char flash *fmtstr);
;     176 void sprintf(char *str, char flash *fmtstr);
;     177 char scanf(char flash *fmtstr);
;     178 char sscanf(char *str,char flash *fmtstr);
;     179 #pragma parptr-
;     180 
;     181 #pragma used-
;     182 
;     183 
;     184 
;     185 // Declare your global variables here
;     186 
;     187 // Konstantendefinitionen
;     188 #define Slaveadresse 		0xC2   	// Eigene Adresse
;     189 #define command_switch	 	0x01	// Kommando Lampe sofort ansteuern
;     190 #define command_dimm_abs	0x02	// Kommando Lampe kontinuierlich absolut dimmen
;     191 #define command_dimm_rel 	0x03	// Kommando Lampe kontinuierlich relativ dimmen
;     192 #define command_ident		0x04	// Gert Identifizieren
;     193 
;     194 char 	Kommando;							// Das empfangene Kommando
;     195 char	Datum;                              // Empfangenes Datum
;     196 
;     197 char 	trigger_count=0;					// Triggerzhler 
;     198 char	ticker_count=0;						// Anzahl der Aufrufe (Dauer feststellen)
;     199 
;     200 // Dimmerwerte in 0-100% sowie Dauer in 0.1sek.-Schritten
;     201 int	startwert,endwert,dauer;
;     202                                             
;     203 // Timer 0 overflow interrupt service routine      
;     204 // Wird bei 10 MHz etwa alle 26ms angesprungen
;     205 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     206 {
_timer0_ovf_isr:
	RCALL __SAVEISR
;     207   trigger_count++;
	INC  R6
;     208   if (trigger_count>3)	// Diese Schleife wird also 10* pro sec. abgearbeitet
	LDI  R30,LOW(3)
	__GTB1RJ 6,11
;     209  	{
;     210  		trigger_count=0; 
	CLR  R6
;     211 		ticker_count++;                                    
	INC  R7
;     212 				
;     213 		if (ticker_count>dauer)
	__GETW1R 12,13
	MOV  R26,R7
	CLR  R27
	SBRC R26,7
	SER  R27
	__GTW12J 0xC
;     214 		
;     215 		 {
;     216 		   ticker_count=0;          
	CLR  R7
;     217 		   if (startwert>endwert)    
	__GTWRRJ 10,11,8,9,13
;     218 		    OCR1AL--;  else		// Neuen Timerwert setzen
	IN   R30,0x2A
	SUBI R30,1
	OUT  0x2A,R30
	SUBI R30,-1
	RJMP _0xE
_0xD:
;     219 			OCR1AL++;
	IN   R30,0x2A
	SUBI R30,-1
	OUT  0x2A,R30
	SUBI R30,1
_0xE:
;     220 		    	    
;     221 	    	 // Jetzt noch kontrollieren, ob der Dimmvorgang abgeschlossen wurde
;     222 	    	 if (OCR1L==endwert) 
	IN   R30,0x2A
	MOV  R26,R30
	__GETW1R 10,11
	CLR  R27
	__EQW12J 0xF
;     223 	    	 {
;     224 		    	TCCR0=0x00; // Timer 0 anhalten
	CLR  R30
	OUT  0x33,R30
;     225 		    	ticker_count=0;
	CLR  R7
;     226 		     }
;     227 		
;     228 	    }
_0xF:
;     229 		
;     230  	}
_0xC:
;     231 	
;     232 }
_0xB:
	RCALL __LOADISR
	RETI
;     233                                                                                      
;     234 // Ganz kurze Pause machen, ca. 12.5 ms bei 8 Mhz
;     235 void delay (short int dauer)
;     236 {                         
_delay:
;     237 	int inner,outer;		// Zhlvariablen
;     238 	
;     239 	for (outer=dauer;outer>0;outer--)  // Outer*0.7ms bei 8 Mhz
	RCALL __SAVELOCR4
;	dauer -> Y+4
;	inner -> R16,R17
;	outer -> R18,R19
	LDD  R30,Y+4
	CLR  R31
	SBRC R30,7
	SER  R31
	__PUTW1R 18,19
_0x13:
	__GETW1R 18,19
	__GTW10 0x12
	RJMP _0x14
_0x11:
	__SUBWRN 18,19,1
	RJMP _0x13
_0x14:
;     240 	 for (inner=255;inner>0;inner--);
	__GETWRN 16,17,255
_0x17:
	__GETW1R 16,17
	__GTW10 0x16
	RJMP _0x18
_0x15:
	__SUBWRN 16,17,1
	RJMP _0x17
_0x18:
	RJMP _0x15
_0x16:
	RJMP _0x11
_0x12:
;     241 	
;     242 } // end of delay 
	RCALL __LOADLOCR4
	ADIW R28,5
	RET
;     243           
;     244                
;     245 // Sendet ein Acknowledge
;     246 void send_acknowledge (void)
;     247 {                     
_send_acknowledge:
;     248 	// Transmitter auf senden schalten
;     249 	PORTD|=32; // PD 5 auf High ziehen
	SBI  0x12,5
;     250 	     
;     251 	// Kurze Pause fr den Bus
;     252 	delay (18);
	LDI  R30,LOW(18)
	ST   -Y,R30
	RCALL _delay
;     253 	
;     254     //  TXC auf Null setzen durch berschreiben mit 1
;     255     USR|=64;
	SBI  0xB,6
;     256     
;     257    	// Slaveadresse senden
;     258    	UDR=Slaveadresse;
	LDI  R30,LOW(194)
	OUT  0xC,R30
;     259 
;     260     // Warten, bis das Zeichen raus ist....
;     261     delay (18);
	LDI  R30,LOW(18)
	ST   -Y,R30
	RCALL _delay
;     262     
;     263 	//  TXC auf Null setzen durch berschreiben mit 1
;     264     USR|=64;
	SBI  0xB,6
;     265     
;     266 	// Kommando hinterher schieben
;     267 	UDR=Kommando;
	OUT  0xC,R4
;     268 	
;     269 	// Hier noch warten, bis die Bytes raus sind
;     270     // Warten, bis das Zeichen raus ist....
;     271     delay (18);
	LDI  R30,LOW(18)
	ST   -Y,R30
	RCALL _delay
;     272      
;     273 	// Transmitter wieder abschalten
;     274 	PORTD&=223; // PD 5 auf Low ziehen
	CBI  0x12,5
;     275 }
	RET
;     276 
;     277 void main(void)
;     278 {
_main:
;     279 // Declare your local variables here
;     280 
;     281 // Input/Output Ports initialization
;     282 // Port B
;     283 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     284 PORTB=0x00;
	CLR  R30
	OUT  0x18,R30
;     285   
;     286 // Port D
;     287 DDRD=32;  // Alles Eingang, PD5 Ausgang
	LDI  R30,LOW(32)
	OUT  0x11,R30
;     288 PORTD=0; 
	CLR  R30
	OUT  0x12,R30
;     289 
;     290 // Timer/Counter 0 initialization
;     291 // Clock source: System Clock
;     292 // Clock value: 9,766 kHz
;     293 // Mode: Output Compare
;     294 // OC0 output: Disconnected
;     295 // TCCR0=0x05; // 00000101 run
;     296 TCCR0=0x00; // 00000000 stopped
	OUT  0x33,R30
;     297 TCNT0=0x00;
	OUT  0x32,R30
;     298    
;     299 // Timer/Counter 1 initialization
;     300 // Clock source: System Clock
;     301 // Clock value: 39,063 kHz
;     302 // Mode: 8 bit Pulse Width Modulation
;     303 // OC1 output: Inverted
;     304 // Noise Canceler: Off
;     305 // Input Capture on Falling Edge
;     306 TCCR1A=0xC1;
	LDI  R30,LOW(193)
	OUT  0x2F,R30
;     307 TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
;     308 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     309 TCNT1L=0x00;
	OUT  0x2C,R30
;     310 OCR1H=0x00;
	OUT  0x2B,R30
;     311 OCR1AL=0xff;			// PWM-Startwert, entspricht 0%
	LDI  R30,LOW(255)
	OUT  0x2A,R30
;     312              
;     313 // UART initialization
;     314 // Communication Parameters: 9 Data, 1 Stop, No Parity
;     315 // UART Receiver: On
;     316 // UART Transmitter: On
;     317 UCR=0x1C;
	LDI  R30,LOW(28)
	OUT  0xA,R30
;     318 // UART Baud rate: 9600 @ 10 MHz
;     319 UBRR=0x40;               
	LDI  R30,LOW(64)
	OUT  0x9,R30
;     320            
;     321 // Timer(s)/Counter(s) Interrupt(s) initialization
;     322 TIMSK=0x02;
	LDI  R30,LOW(2)
	OUT  0x39,R30
;     323 
;     324 // Analog Comparator initialization
;     325 // Analog Comparator: Off
;     326 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     327 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     328             
;     329 // Global enable interrupts
;     330 #asm("sei")
	sei
;     331 
;     332 while (1)
_0x1B:
;     333       {
;     334       // Place your code here
;     335   	   
;     336       // Warten auf empfangenes Zeichen 
;     337       while (!(USR & 0x80)) 
_0x1D:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	__EQB10 0x1E
;     338       {                                 
;     339       }
	RJMP _0x1D
_0x1E:
;     340       // Ist das 9. Datenbit gesetzt und die Slaveadresse gltig ?
;     341       if ( (UDR==Slaveadresse) && ( UCR & 0x02) )
	IN   R30,0xC
	__EQB1NJ 0x20,194
	IN   R30,0xA
	ANDI R30,LOW(0x2)
	__NEB10 0x20
	RJMP _0x21
_0x20:
	RJMP _0x1F
_0x21:
;     342       {                                 
;     343        // OK, wir sollten uns nun also angesprochen fhlen und den Arsch vom Sofa erheben.......
;     344        
;     345        // Warten auf Kommando
;     346        while (!(USR & 0x80)) 
_0x22:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	__EQB10 0x23
;     347        {                               
;     348        }	
	RJMP _0x22
_0x23:
;     349        Kommando=UDR;
	IN   R4,12
;     350                                                             
;     351        // Hier gelandet ist also der Slave korrekt angesprochen und das Kommando ist auch 
;     352        // schon rbergekommen
;     353        
;     354        // send_acknowledge ();
;     355                 
;     356        // Jetzt kann mit der Dekodierung begonnen werden
;     357   
;     358   	   switch (Kommando)
	MOV  R30,R4
	RJMP _0x26
;     359        {              
;     360         
;     361         case command_switch:           // Lampe direkt ansteuern
_0x27:
;     362         	 {      
;     363                 // Warten auf das nchste Zeichen
;     364      		   while (!(USR & 0x80)) 
_0x28:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	__EQB10 0x29
;     365        		    {                               
;     366        		    }	
	RJMP _0x28
_0x29:
;     367        		  Datum=UDR;      // (0-100% Helligkeit)   
	IN   R5,12
;     368        		  
;     369        		  TCCR0=0x00; // Timer 0 anhalten
	CLR  R30
	OUT  0x33,R30
;     370                      		  
;     371        		  // Wert umrechnen  
;     372        		  OCR1AL=( 255- (Datum*2.5) ); // Von % in Timerwert umrechnen und Register sofort setzen
	MOV  R30,R5
	RCALL __MOVED12
	RCALL __CBD2
	RCALL __CDF2
	__GETD1N 0x40200000
	RCALL __MULF12
	__GETD2N 0x437F0000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	OUT  0x2A,R30
;     373        		  
;     374         	  send_acknowledge ();		// Aknowledge rauschieben
	RCALL _send_acknowledge
;     375         	  break;
	RJMP _0x25
;     376         	 }
;     377         
;     378         case command_dimm_abs:          // Lampe absolut dimmen
_0x2A:
;     379         	 {                                                   
;     380         	 
;     381         	  // Warten auf das nchste Zeichen (Startwert)
;     382      		   while (!(USR & 0x80)) 
_0x2B:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	__EQB10 0x2C
;     383        		    {                               
;     384        		    }	
	RJMP _0x2B
_0x2C:
;     385        		  startwert=UDR;      // (0-100% Helligkeit)   
	IN   R30,0xC
	CLR  R31
	__PUTW1R 8,9
;     386 
;     387         	  // Warten auf das nchste Zeichen (Endwert)
;     388      		   while (!(USR & 0x80)) 
_0x2D:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	__EQB10 0x2E
;     389        		    {                               
;     390        		    }	
	RJMP _0x2D
_0x2E:
;     391        		  endwert=UDR;      // (0-100% Helligkeit)   
	IN   R30,0xC
	CLR  R31
	__PUTW1R 10,11
;     392                  
;     393        		  // Warten auf das nchste Zeichen (Dauer in 0.1s)
;     394      		   while (!(USR & 0x80))                          
_0x2F:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	__EQB10 0x30
;     395        		    {                               
;     396        		    }	
	RJMP _0x2F
_0x30:
;     397        		  dauer=UDR;      // (0-100% Helligkeit)        *)
	IN   R30,0xC
	CLR  R31
	__PUTW1R 12,13
;     398        		  
;     399        	   //	  startwert=0;
;     400        	   //	  endwert=100;
;     401        	   //	  dauer=255;
;     402        		  
;     403        		  // Umrechnung von % in Registerwerte
;     404        		  startwert=( 255- (startwert*2.5) ); 
	__GETW1R 8,9
	RCALL __MOVED12
	RCALL __CWD2
	RCALL __CDF2
	__GETD1N 0x40200000
	RCALL __MULF12
	__GETD2N 0x437F0000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	__PUTW1R 8,9
;     405        		  endwert=( 255- (endwert*2.5) ); 
	__GETW1R 10,11
	RCALL __MOVED12
	RCALL __CWD2
	RCALL __CDF2
	__GETD1N 0x40200000
	RCALL __MULF12
	__GETD2N 0x437F0000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	__PUTW1R 10,11
;     406        		                                        
;     407 			//	Berechnung der Steigung
;     408 			//	steigung=(endwert-startwert)/dauer;
;     409        		             
;     410        		  	// Startwert setzen
;     411        		  	OCR1AL=startwert;
	__GETW1R 8,9
	OUT  0x2A,R30
;     412        		  	
;     413        		  	// Timer 0 starten, also das Dimmen anstossen
;     414        		  	ticker_count=0; // Anzahl der Aufrufe bisher
	CLR  R7
;     415        		  	TCCR0=0x03; 	// 00000011 run CK/64
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     416        		  	                                  		  
;     417         	  send_acknowledge ();		// Aknowledge rauschieben
	RCALL _send_acknowledge
;     418         	  break;
	RJMP _0x25
;     419         	 }
;     420 
;     421 		case command_dimm_rel:			// Lampe relativ dimmen
_0x31:
;     422 			 {                          // 2 Bytes reinholen
;     423 			 
;     424 		 startwert=OCR1L;      // Aktuellen PWM-Wert holen
	IN   R30,0x2A
	CLR  R31
	__PUTW1R 8,9
;     425       			
;     426         	  // Warten auf das nchste Zeichen (Endwert)
;     427      		   while (!(USR & 0x80)) 
_0x32:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	__EQB10 0x33
;     428        		    {                               
;     429        		    }	
	RJMP _0x32
_0x33:
;     430        		  endwert=UDR;      // (0-100% Helligkeit)   
	IN   R30,0xC
	CLR  R31
	__PUTW1R 10,11
;     431        
;     432                  
;     433        		  // Warten auf das nchste Zeichen (Dauer in 0.1s)
;     434      		   while (!(USR & 0x80))                          
_0x34:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	__EQB10 0x35
;     435        		    {                               
;     436        		    }	
	RJMP _0x34
_0x35:
;     437        		  dauer=UDR;      // (0-100% Helligkeit)        *)
	IN   R30,0xC
	CLR  R31
	__PUTW1R 12,13
;     438        		  
;     439        		  // Umrechnung in Registerwerte
;     440        		  endwert=( 255- (endwert*2.5) ); 
	__GETW1R 10,11
	RCALL __MOVED12
	RCALL __CWD2
	RCALL __CDF2
	__GETD1N 0x40200000
	RCALL __MULF12
	__GETD2N 0x437F0000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	__PUTW1R 10,11
;     441        		    
;     442        		  	// Timer 0 starten, also das Dimmen anstossen
;     443        		  	ticker_count=0; // Anzahl der Aufrufe bisher
	CLR  R7
;     444        		  	
;     445        		  	// Nur starten, wenn neuer Wert
;     446        		  	if (startwert!=endwert)
	__NEWRRJ 10,11,8,9,54
;     447        		  		TCCR0=0x03; 	// 00000011 run CK/64
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     448        		            
;     449        		  while (1)
_0x36:
_0x37:
;     450        		  {
;     451        		  }
	RJMP _0x37
_0x38:
;     452        		                    			 
;     453 			  send_acknowledge ();		// Aknowledge rauschieben
	RCALL _send_acknowledge
;     454         	  break;
	RJMP _0x25
;     455        		 }
;     456 
;     457         case command_ident:				// Gert identifizieren
_0x39:
;     458 			 {                          
;     459 			  send_acknowledge ();		// Aknowledge rauschieben
	RCALL _send_acknowledge
;     460         	  break;
	RJMP _0x25
;     461        		 }
;     462 
;     463    			 
;     464        } // Von Switch 
	RJMP _0x25
_0x26:
	CLR  R31
	SBRC R30,7
	SER  R31
	RCALL __SWITCH
	.DW  _0x27*2
	.DW   0x1
	.DW  _0x2A*2
	.DW   0x2
	.DW  _0x31*2
	.DW   0x3
	.DW  _0x39*2
	.DW   0x4
	.DW   0x0
_0x25:
;     465        
;     466        } // Von gltiger Slaveadresse mit 9. Datenbit gesetzt
;     467        
;     468       };
_0x1F:
	RJMP _0x1B
_0x1C:
;     469 }
	RET

__GLOBAL_INI_TBL:
	.DW  0

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CBD2:
	CLR  R27
	CLR  R24
	CLR  R25
	SBRS R26,7
	RET
	SER  R27
	SER  R24
	SER  R25
	RET

__CWD2:
	CLR  R24
	CLR  R25
	SBRS R27,7
	RET
	SER  R24
	SER  R25
	RET

__MOVED12:
	MOV  R26,R30
	MOV  R27,R31
	MOV  R24,R22
	MOV  R25,R23
	RET

__SWITCH:
	MOV  R26,R30
	MOV  R27,R31
	POP  R31
	POP  R30
	LSL  R30
	ROL  R31
__SWLOOP:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	ADIW R24,0
	BREQ __SWEXIT
	LPM
	ADIW R30,1
	CP   R26,R0
	LPM
	LD   R1,Z+
	CPC  R27,R0
	BRNE __SWLOOP
	MOV  R30,R24
	MOV  R31,R25
__SWEXIT:
	LSR  R31
	ROR  R30
	IJMP

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BREQ __CFD10
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	RJMP __MAXRES
__CFD11:
	CPI  R21,24
	BRLO __CFD12
__CFD10:
	RJMP __MINRES
__CFD12:
	CLR  R23
__CFD13:
	CPI  R21,8
	BRLO __CFD14
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD13
__CFD14:
	TST  R21
	BREQ __CFD16
__CFD15:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD15
__CFD16:
	CLR  R23
	TST  R0
	BRPL __CFD17
	RCALL __NEGMAN1
	SER  R23
__CFD17:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1

__REPACK:
	LSL  R22
	LDI  R21,0x80
	EOR  R21,R23
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __MINRES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MAXRES:
	SER  R30
	SER  R31
	ORI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MINRES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __MINRES
	CPI  R25,0x80
	BREQ __MINRES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVS __MAXRES
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MAXRES
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__CPW01:
	CLR  R0
	CP   R0,R30
	CPC  R0,R31
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

	.ORG 0

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP _timer0_ovf_isr
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
