;CodeVisionAVR C Compiler V1.0.1.4b Evaluation
;(C) Copyright 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
;http://infotech.ir.ro
;e-mail:dhptechn@ir.ro , hpinfotech@mail.com

;Chip type           : AT90S2313
;Clock frequency     : 8,000000 MHz
;Memory model        : Tiny
;Optimize for        : Size
;Internal SRAM size  : 128
;External SRAM size  : 0
;Data Stack size     : 32
;Promote char to int : No
;char is unsigned    : Yes
;Automatic register allocation : On
;Use AVR Studio Terminal I/O   : No

	.DEVICE AT90S2313
	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU UBRR=0x9
	.EQU UCR=0xA
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __JMPZ
	BRNE __FALSE
	RJMP _@0
__FALSE:
	.ENDM

	.MACRO __JMPNZ
	BREQ __FALSE
	RJMP _@0
__FALSE:
	.ENDM

	.MACRO __EQB10
	TST  R30
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB10
	CPI  R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB10
	CLR  R0
	CP   R0,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB10
	CLR  R0
	CP   R0,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB10
	CPI  R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB10
	TST  R30
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW10
	SBIW R30,0
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW10
	SBIW R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW10
	RCALL __CPW01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW10
	RCALL __CPW01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW10
	SBIW R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW10
	SBIW R30,0
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD10
	RCALL __CPD10
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED10
	RCALL __CPD10
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD10
	RCALL __CPD01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED10
	RCALL __CPD01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD10
	RCALL __CPD10
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED10
	RCALL __CPD10
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB12J
	CP   R30,R26
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB12J
	CP   R30,R26
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12J
	CP   R30,R26
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12J
	CP   R26,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12J
	CP   R26,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12J
	CP   R30,R26
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12UJ
	CP   R30,R26
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12UJ
	CP   R26,R30
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12UJ
	CP   R26,R30
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12UJ
	CP   R30,R26
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW12J
	CP   R30,R26
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW12J
	CP   R30,R26
	CPC  R31,R27
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12J
	CP   R30,R26
	CPC  R31,R27
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12J
	CP   R26,R30
	CPC  R27,R31
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12J
	CP   R26,R30
	CPC  R27,R31
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12J
	CP   R30,R26
	CPC  R31,R27
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD12J
	RCALL __CPD12
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED12J
	RCALL __CPD12
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12J
	RCALL __CPD12
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12J
	RCALL __CPD21
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12J
	RCALL __CPD21
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12J
	RCALL __CPD12
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12UJ
	RCALL __CPD12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12UJ
	RCALL __CPD21
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12UJ
	RCALL __CPD21
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12UJ
	RCALL __CPD12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCS __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEF12J
	RCALL __CMPF12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTF12J
	RCALL __CMPF12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCC __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB1NJ
	CPI  R30,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB1NJ
	CPI  R30,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB2NJ
	CPI  R26,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB2NJ
	CPI  R26,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEBN1J
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTBN1J
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEBN1UJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTBN1UJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NJ
	CPI  R26,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NJ
	CPI  R26,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NUJ
	CPI  R26,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NUJ
	CPI  R26,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __BITSREG0
	BRBC @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __BITSREG1
	BRBS @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBR0
	TST  R@0
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR0
	TST  R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR0
	CLR  R0
	CP   R0,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR0
	CLR  R0
	CP   R0,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR0
	TST  R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBR0
	TST  R@0
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBRRJ
	CP   R@0,R@1
	BREQ __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __NEBRRJ
	CP   R@0,R@1
	BRNE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRJ
	CP   R@0,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRJ
	CP   R@1,R@0
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRJ
	CP   R@1,R@0
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRJ
	CP   R@0,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRUJ
	CP   R@0,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRUJ
	CP   R@1,R@0
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRUJ
	CP   R@1,R@0
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRUJ
	CP   R@0,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQW1NJ
	LDI  R27,HIGH(@1)
	CPI  R30,LOW(@1)
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __NEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEB1RJ
	CP   R30,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RJ
	CP   R@0,R30
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RJ
	CP   R@0,R30
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RJ
	CP   R30,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEB1RUJ
	CP   R30,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RUJ
	CP   R@0,R30
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RUJ
	CP   R@0,R30
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RUJ
	CP   R30,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2J
	CP   R@0,R26
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2J
	CP   R26,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2J
	CP   R26,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2J
	CP   R@0,R26
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2UJ
	CP   R@0,R26
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2UJ
	CP   R26,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2UJ
	CP   R26,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2UJ
	CP   R@0,R26
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQBRNJ
	CPI  R@0,LOW(@2)
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBRNJ
	CPI  R@0,LOW(@2)
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __TESTSREG
	LDI  R30,1
	BRBS @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __NTESTSREG
	LDI  R30,1
	BRBC @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __EQB1NJS
	CPI  R30,LOW(@1)
	BRNE _@0
	.ENDM

	.MACRO __EQB2NJS
	CPI  R26,LOW(@1)
	BRNE _@0
	.ENDM

	.MACRO __NEB1NJS
	CPI  R30,LOW(@1)
	BREQ _@0
	.ENDM

	.MACRO __NEB2NJS
	CPI  R26,LOW(@1)
	BREQ _@0
	.ENDM

	.MACRO __LEBN1JS
	CPI  R30,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __LEBN1UJS
	CPI  R30,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __GTBN1JS
	CPI  R30,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __GTBN1UJS
	CPI  R30,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __GEB1NJS
	CPI  R30,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __GEB2NJS
	CPI  R26,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __GEB1NUJS
	CPI  R30,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __GEB2NUJS
	CPI  R26,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __LTB1NJS
	CPI  R30,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __LTB2NJS
	CPI  R26,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __LTB1NUJS
	CPI  R30,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __LTB2NUJS
	CPI  R26,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __EQBR0S
	TST  R@0
	BRNE _@1
	.ENDM

	.MACRO __GEBR0S
	TST  R@0
	BRLT _@1
	.ENDM

	.MACRO __GTBR0S
	CLR  R0
	CP   R0,R@0
	BRGE _@1
	.ENDM

	.MACRO __LEBR0S
	CLR  R0
	CP   R0,R@0
	BRLT _@1
	.ENDM

	.MACRO __LTBR0S
	TST  R@0
	BRGE _@1
	.ENDM

	.MACRO __NEBR0S
	TST  R@0
	BREQ _@1
	.ENDM

	.MACRO __EQBRRJS
	CP   R@0,R@1
	BRNE _@2
	.ENDM

	.MACRO __NEBRRJS
	CP   R@0,R@1
	BREQ _@2
	.ENDM

	.MACRO __LEBRRJS
	CP   R@0,R@1
	BRLT _@2
	.ENDM

	.MACRO __GEBRRJS
	CP   R@1,R@0
	BRLT _@2
	.ENDM

	.MACRO __LTBRRJS
	CP   R@1,R@0
	BRGE _@2
	.ENDM

	.MACRO __GTBRRJS
	CP   R@0,R@1
	BRGE _@2
	.ENDM

	.MACRO __LEBRRUJS
	CP   R@0,R@1
	BRLO _@2
	.ENDM

	.MACRO __GEBRRUJS
	CP   R@1,R@0
	BRLO _@2
	.ENDM

	.MACRO __LTBRRUJS
	CP   R@1,R@0
	BRSH _@2
	.ENDM

	.MACRO __GTBRRUJS
	CP   R@0,R@1
	BRSH _@2
	.ENDM

	.MACRO __EQW1NJS
	LDI  R27,HIGH(@1)
	CPI  R30,LOW(@1)
	CPC  R31,R27
	BRNE _@0
	.ENDM

	.MACRO __EQWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE _@4
	.ENDM

	.MACRO __NEWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ _@4
	.ENDM

	.MACRO __LEWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT _@4
	.ENDM

	.MACRO __GEWRRJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT _@4
	.ENDM

	.MACRO __LTWRRJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE _@4
	.ENDM

	.MACRO __GTWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE _@4
	.ENDM

	.MACRO __LEWRRUJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO _@4
	.ENDM

	.MACRO __GEWRRUJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO _@4
	.ENDM

	.MACRO __LTWRRUJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH _@4
	.ENDM

	.MACRO __GTWRRUJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH _@4
	.ENDM

	.MACRO __EQBRNJS
	CPI  R@0,LOW(@2)
	BRNE _@1
	.ENDM

	.MACRO __NEBRNJS
	CPI  R@0,LOW(@2)
	BREQ _@1
	.ENDM

	.MACRO __GEBRNJS
	CPI  R@0,LOW(@2)
	BRLT _@1
	.ENDM

	.MACRO __LTBRNJS
	CPI  R@0,LOW(@2)
	BRGE _@1
	.ENDM

	.MACRO __GEBRNUJS
	CPI  R@0,LOW(@2)
	BRLO _@1
	.ENDM

	.MACRO __LTBRNUJS
	CPI  R@0,LOW(@2)
	BRSH _@1
	.ENDM

	.MACRO __LEB1RJS
	CP   R30,R@0
	BRLT _@1
	.ENDM

	.MACRO __GEB1RJS
	CP   R@0,R30
	BRLT _@1
	.ENDM

	.MACRO __LTB1RJS
	CP   R@0,R30
	BRGE _@1
	.ENDM

	.MACRO __GTB1RJS
	CP   R30,R@0
	BRGE _@1
	.ENDM

	.MACRO __LEB1RUJS
	CP   R30,R@0
	BRLO _@1
	.ENDM

	.MACRO __GEB1RUJS
	CP   R@0,R30
	BRLO _@1
	.ENDM

	.MACRO __LTB1RUJS
	CP   R@0,R30
	BRSH _@1
	.ENDM

	.MACRO __GTB1RUJS
	CP   R30,R@0
	BRSH _@1
	.ENDM

	.MACRO __LEBR2JS
	CP   R@0,R26
	BRLT _@1
	.ENDM

	.MACRO __GEBR2JS
	CP   R26,R@0
	BRLT _@1
	.ENDM

	.MACRO __LTBR2JS
	CP   R26,R@0
	BRGE _@1
	.ENDM

	.MACRO __GTBR2JS
	CP   R@0,R26
	BRGE _@1
	.ENDM

	.MACRO __LEBR2UJS
	CP   R@0,R26
	BRLO _@1
	.ENDM

	.MACRO __GEBR2UJS
	CP   R26,R@0
	BRLO _@1
	.ENDM

	.MACRO __LTBR2UJS
	CP   R26,R@0
	BRSH _@1
	.ENDM

	.MACRO __GTBR2UJS
	CP   R@0,R26
	BRSH _@1
	.ENDM

	.MACRO __LEW1RJS
	CP   R30,R@0
	CPC  R31,R@1
	BRLT _@2
	.ENDM

	.MACRO __GEW1RJS
	CP   R@0,R30
	CPC  R@1,R31
	BRLT _@2
	.ENDM

	.MACRO __LTW1RJS
	CP   R@0,R30
	CPC  R@1,R31
	BRGE _@2
	.ENDM

	.MACRO __GTW1RJS
	CP   R30,R@0
	CPC  R31,R@1
	BRGE _@2
	.ENDM

	.MACRO __LEW1RUJS
	CP   R30,R@0
	CPC  R31,R@1
	BRLO _@2
	.ENDM

	.MACRO __GEW1RUJS
	CP   R@0,R30
	CPC  R@1,R31
	BRLO _@2
	.ENDM

	.MACRO __LTW1RUJS
	CP   R@0,R30
	CPC  R@1,R31
	BRSH _@2
	.ENDM

	.MACRO __GTW1RUJS
	CP   R30,R@0
	CPC  R31,R@1
	BRSH _@2
	.ENDM

	.MACRO __LEWR2JS
	CP   R@0,R26
	CPC  R@1,R27
	BRLT _@2
	.ENDM

	.MACRO __GEWR2JS
	CP   R26,R@0
	CPC  R27,R@1
	BRLT _@2
	.ENDM

	.MACRO __LTWR2JS
	CP   R26,R@0
	CPC  R27,R@1
	BRGE _@2
	.ENDM

	.MACRO __GTWR2JS
	CP   R@0,R26
	CPC  R@1,R27
	BRGE _@2
	.ENDM

	.MACRO __LEWR2UJS
	CP   R@0,R26
	CPC  R@1,R27
	BRLO _@2
	.ENDM

	.MACRO __GEWR2UJS
	CP   R26,R@0
	CPC  R27,R@1
	BRLO _@2
	.ENDM

	.MACRO __LTWR2UJS
	CP   R26,R@0
	CPC  R27,R@1
	BRSH _@2
	.ENDM

	.MACRO __GTWR2UJS
	CP   R@0,R26
	CPC  R@1,R27
	BRSH _@2
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.CSEG
	.ORG 0x0B

	.INCLUDE "backlight.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31
	OUT  MCUCR,R30

;CLEAR R2-R15
	LDI  R24,14
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	MOV  R1,R0
	ADIW R30,1
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	MOV  R26,R0
	ADIW R30,1
	LPM
	MOV  R27,R0
	ADIW R30,1
	LPM
	MOV  R24,R0
	ADIW R30,1
	LPM
	MOV  R25,R0
	ADIW R30,1
__GLOBAL_INI_LOOP:
	LPM
	ST   X+,R0
	ADIW R30,1
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x7F)

	RJMP _main

	.ESEG
	.ORG 1

	.DSEG
	.ORG 0x80
;       1 /**************************************
;       2        
;       3 Chip type        : AT90S2313
;       4 Clock frequency  : 8,000000 MHz
;       5 Memory model     : Tiny
;       6 Internal RAM size: 128
;       7 External RAM size: 0
;       8 Data Stack size  : 32
;       9 ***************************************/
;      10 
;      11 #include <90s2313.h>
;      12 // CodeVisionAVR C Compiler
;      13 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      14 
;      15 // I/O registers definitions for the AT90S2313
;      16 
;      17 #ifndef _90S2313_INCLUDED_
;      18 #define _90S2313_INCLUDED_
;      19 
;      20 #pragma used+
;      21 sfrb ACSR=8;
;      22 sfrb UBRR=9;
;      23 sfrb UCR=0xa;
;      24 sfrb USR=0xb;
;      25 sfrb UDR=0xc;
;      26 sfrb PIND=0x10;
;      27 sfrb DDRD=0x11;
;      28 sfrb PORTD=0x12;
;      29 sfrb PINB=0x16;
;      30 sfrb DDRB=0x17;
;      31 sfrb PORTB=0x18;
;      32 sfrb EECR=0x1c;
;      33 sfrb EEDR=0x1d;
;      34 sfrb EEAR=0x1e;
;      35 sfrb WDTCR=0x21;
;      36 sfrb ICR1L=0x24;
;      37 sfrb ICR1H=0x25;
;      38 sfrw ICR1=0x24;   // 16 bit access
;      39 sfrb OCR1L=0x2a;
;      40 sfrb OCR1H=0x2b;
;      41 sfrw OCR1=0x2a;   // 16 bit access
;      42 sfrb TCNT1L=0x2c;
;      43 sfrb TCNT1H=0x2d;
;      44 sfrw TCNT1=0x2c;  // 16 bit access
;      45 sfrb TCCR1B=0x2e;
;      46 sfrb TCCR1A=0x2f;
;      47 sfrb TCNT0=0x32;
;      48 sfrb TCCR0=0x33;
;      49 sfrb MCUSR=0x34;
;      50 sfrb MCUCR=0x35;
;      51 sfrb TIFR=0x38;
;      52 sfrb TIMSK=0x39;
;      53 sfrb GIFR=0x3a;
;      54 sfrb GIMSK=0x3b;
;      55 sfrb SPL=0x3d;
;      56 sfrb SREG=0x3f;
;      57 #pragma used-
;      58 
;      59 #define OCR1AL OCR1L
;      60 #define OCR1AH OCR1H
;      61 
;      62 // Interrupt vectors definitions
;      63 
;      64 #define EXT_INT0 2
;      65 #define EXT_INT1 3
;      66 #define TIM1_CAPT 4
;      67 #define TIM1_COMP 5
;      68 #define TIM1_OVF 6
;      69 #define TIM0_OVF 7
;      70 #define UART_RXC 8
;      71 #define UART_DRE 9
;      72 #define UART_TXC 10
;      73 #define ANA_COMP 11
;      74 
;      75 #endif
;      76 
;      77 
;      78 // Standard Input/Output functions
;      79 #include <stdio.h>
;      80 // CodeVisionAVR C Compiler
;      81 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      82 
;      83 // Prototypes for standard I/O functions
;      84 
;      85 #ifndef _STDIO_INCLUDED_
;      86 #define _STDIO_INCLUDED_
;      87 
;      88 #ifndef NULL
;      89 #define NULL 0
;      90 #endif
;      91 
;      92 #pragma used+
;      93 
;      94 #pragma warn-
;      95 #ifndef _DEBUG_TERMINAL_IO_
;      96 #ifndef _ALTERNATE_GETCHAR_
;      97 char getchar(void)
;      98 {

	.CSEG
_getchar:
;      99 #asm
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
;     103 #endasm
;     104 }
	RET
;     105 #endif
;     106 
;     107 #ifndef _ALTERNATE_PUTCHAR_
;     108 void putchar(char c)
;     109 {
_putchar:
;     110 #asm
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
;     115 #endasm
;     116 }
	RJMP _0x27
;     117 #endif
;     118 #else
;     119 // Used for AVR Studio Terminal I/O
;     120 // DON'T CHANGE!
;     121 char getchar(void)
;     122 {
;     123 #asm
;     124      push  r16
;     125      push  r17
;     126 __getchar0:
;     127      rcall __c_getchar
;     128      cpi   r17,0xff
;     129      breq  __getchar0
;     130      mov   r30,r16
;     131      pop   r17
;     132      pop   r16
;     133 #endasm
;     134 }
;     135 
;     136 void putchar(char c)
;     137 {
;     138 #asm
;     139     mov   r30,r16
;     140     ld    r16,y
;     141     rcall __c_putchar
;     142     mov   r16,r30
;     143 #endasm
;     144 }
;     145 
;     146 void _c_getchar(void)
;     147 {
;     148 }
;     149 
;     150 void _c_putchar(void)
;     151 {
;     152 }
;     153 #endif
;     154 
;     155 #ifdef _WARNINGS_ON_
;     156 #pragma warn+
;     157 #endif
;     158 
;     159 void puts(char *str);
;     160 void putsf(char flash *str);
;     161 
;     162 #ifdef _MODEL_TINY_
;     163 char *gets(char *str,unsigned char len);
;     164 #endif
;     165 
;     166 #ifdef _MODEL_SMALL_
;     167 char *gets(char *str,unsigned int len);
;     168 #endif
;     169 
;     170 #pragma parptr+
;     171 void printf(char flash *fmtstr);
;     172 void sprintf(char *str, char flash *fmtstr);
;     173 char scanf(char flash *fmtstr);
;     174 char sscanf(char *str,char flash *fmtstr);
;     175 #pragma parptr-
;     176 
;     177 #pragma used-
;     178 
;     179 #endif
;     180 
;     181 
;     182 // Declare your global variables here
;     183 
;     184 // Konstantendefinitionen
;     185 #define Slaveadresse 		0x90   	// Eigene Adresse
;     186 #define command_switch	 	0x01	// Kommando Lampen sofort ansteuern
;     187 #define command_sensor		0x02	// Personendetektor auslesen
;     188 #define command_ident		0x04	// Gert Identifizieren
;     189 
;     190 char 	Kommando;			// Das empfangene Kommando
;     191 char	Datum;              // Empfangenes Datum
;     192 char 	Sensor;				// Sensordaten
;     193 
;     194 unsigned int 	Seconds, ticker=0;			// Systemticker
;     195                                      
;     196 // Timer 0 overflow interrupt service routine      
;     197 // Wird bei 10 MHz etwa alle 26ms angesprungen
;     198 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     199 {
_timer0_ovf_isr:
	RCALL __SAVEISR
;     200   ticker++; 
	__GETW1R 9,10
	ADIW R30,1
	__PUTW1R 9,10
;     201   
;     202   if ( !(PINB & 32) )
	IN   R30,0x16
	ANDI R30,LOW(0x20)
	BRNE _0xB
;     203    {                            
;     204    	Sensor=1;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     205    }						// Sensor ist aktiv
;     206         
;     207   if (ticker==40)
_0xB:
	__GETW2R 9,10
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xC
;     208    {
;     209      Seconds++;  			// Eine Sekunde ist verstrichen
	__GETW1R 7,8
	ADIW R30,1
	__PUTW1R 7,8
;     210      ticker=0;
	CLR  R9
	CLR  R10
;     211    }
;     212 }
_0xC:
	RCALL __LOADISR
	RETI
;     213                                                                                      
;     214 // Ganz kurze Pause machen, ca. 12.5 ms bei 8 Mhz
;     215 void delay (short int dauer)
;     216 {                         
_delay:
;     217 	int inner,outer;		// Zhlvariablen
;     218 	
;     219 	for (outer=dauer;outer>0;outer--)  // Outer*0.7ms bei 8 Mhz
	RCALL __SAVELOCR4
;	dauer -> Y+4
;	inner -> R16,R17
;	outer -> R18,R19
	__GETWRS 18,19,4
_0xE:
	__GETW1R 18,19
	RCALL __CPW01
	BRGE _0x10
;     220 	 for (inner=255;inner>0;inner--);
	__GETWRN 16,17,255
_0x11:
	__GETW1R 16,17
	RCALL __CPW01
	BRGE _0x13
_0x12:
	__SUBWRN 16,17,1
	RJMP _0x11
_0x13:
_0xF:
	__SUBWRN 18,19,1
	RJMP _0xE
_0x10:
;     221 	
;     222 } // end of delay 
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
;     223           
;     224                
;     225 // Sendet ein Acknowledge
;     226 void send_acknowledge (char typ)				// Typ=0 -> keine Zusatzinformation senden
;     227 {                     
_send_acknowledge:
;     228 	// Transmitter auf senden schalten
;     229 	PORTD|=64; // PD 6 auf High ziehen
	SBI  0x12,6
;     230 	     
;     231 	// Kurze Pause fr den Bus
;     232 	delay (18);
	RCALL SUBOPT_0x0
;     233 	
;     234     //  TXC auf Null setzen durch berschreiben mit 1
;     235     USR|=64;
	SBI  0xB,6
;     236     
;     237    	// Slaveadresse senden
;     238    	UDR=Slaveadresse;
	LDI  R30,LOW(144)
	OUT  0xC,R30
;     239 
;     240     // Warten, bis das Zeichen raus ist....
;     241     delay (18);
	RCALL SUBOPT_0x0
;     242                             
;     243     // Auswerten, ob Zusatzinformationen gewnscht werden
;     244     if (typ!=0)
	LD   R30,Y
	TST  R30
	BREQ _0x15
;     245      {
;     246       Kommando=Kommando+(Sensor*16);	// Information in den oberen 4 Bits ausgeben
	MOV  R26,R6
	LDI  R30,LOW(16)
	RCALL __MULB12U
	ADD  R4,R30
;     247       Sensor=0;                         // Sensor wurde ausgelesen, zurcksetzen
	CLR  R6
;     248      }
;     249     
;     250 	//  TXC auf Null setzen durch berschreiben mit 1
;     251     USR|=64;
_0x15:
	SBI  0xB,6
;     252     
;     253 	// Kommando hinterher schieben
;     254 	UDR=Kommando;
	OUT  0xC,R4
;     255 	
;     256 	// Hier noch warten, bis die Bytes raus sind
;     257     // Warten, bis das Zeichen raus ist....
;     258     delay (18);
	RCALL SUBOPT_0x0
;     259      
;     260 	// Transmitter wieder abschalten
;     261 	PORTD&=255-64; // PD 6 auf Low ziehen
	CBI  0x12,6
;     262 }
_0x27:
	ADIW R28,1
	RET
;     263 
;     264 void main(void)
;     265 {
_main:
;     266 // Declare your local variables here
;     267 
;     268 // Input/Output Ports initialization
;     269 // Port B
;     270 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     271 PORTB=0x00;
	CLR  R30
	OUT  0x18,R30
;     272   
;     273 // Port D
;     274 DDRD=64; 	// Alles Eingang, PD6 Ausgang, D5=Sensoreingang
	LDI  R30,LOW(64)
	OUT  0x11,R30
;     275 PORTD=32;	// PD5 mit Pull-Up versehen 
	LDI  R30,LOW(32)
	OUT  0x12,R30
;     276 
;     277 // Timer/Counter 0 initialization
;     278 // Clock source: System Clock
;     279 // Clock value: 9,766 kHz
;     280 // Mode: Output Compare
;     281 // OC0 output: Disconnected
;     282 // TCCR0=0x05; // 00000101 run
;     283 TCCR0=0x00; // 00000000 stopped
	CLR  R30
	OUT  0x33,R30
;     284 TCNT0=0x00;
	OUT  0x32,R30
;     285    
;     286 // Timer/Counter 1 initialization
;     287 // Clock source: System Clock
;     288 // Clock value: 39,063 kHz
;     289 // Mode: 8 bit Pulse Width Modulation
;     290 // OC1 output: Inverted
;     291 // Noise Canceler: Off
;     292 // Input Capture on Falling Edge
;     293 TCCR1A=0xC1;
	LDI  R30,LOW(193)
	OUT  0x2F,R30
;     294 TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
;     295 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     296 TCNT1L=0x00;
	OUT  0x2C,R30
;     297 OCR1H=0x00;
	OUT  0x2B,R30
;     298 OCR1AL=0xff;			// PWM-Startwert, entspricht 0%
	LDI  R30,LOW(255)
	OUT  0x2A,R30
;     299              
;     300 // UART initialization
;     301 // Communication Parameters: 9 Data, 1 Stop, No Parity
;     302 // UART Receiver: On
;     303 // UART Transmitter: On
;     304 UCR=0x1C;
	LDI  R30,LOW(28)
	OUT  0xA,R30
;     305 // UART Baud rate: 9600 @ 10 MHz
;     306 UBRR=0x40;               
	LDI  R30,LOW(64)
	OUT  0x9,R30
;     307            
;     308 // Timer(s)/Counter(s) Interrupt(s) initialization
;     309 TIMSK=0x02;
	LDI  R30,LOW(2)
	OUT  0x39,R30
;     310 
;     311 // Analog Comparator initialization
;     312 // Analog Comparator: Off
;     313 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     314 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     315                  
;     316 // Timer 0 starten
;     317 TCCR0=0x03; 	// 00000011 run CK/64
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     318             
;     319 // Global enable interrupts
;     320 #asm("sei")
	sei
;     321 
;     322 while (1)
_0x17:
;     323       {
;     324       // Place your code here
;     325   	   
;     326       // Warten auf empfangenes Zeichen 
;     327       while (!(USR & 0x80)) 
_0x19:
	RCALL SUBOPT_0x1
	BRNE _0x1A
;     328       {                                 
;     329       }
	RJMP _0x19
_0x1A:
;     330       // Ist das 9. Datenbit gesetzt und die Slaveadresse gltig ?
;     331       if ( (UDR==Slaveadresse) && ( UCR & 0x02) )
	IN   R30,0xC
	__EQB1NJS 0x1C,144
	IN   R30,0xA
	ANDI R30,LOW(0x2)
	BREQ _0x1C
	RJMP _0x1D
_0x1C:
	RJMP _0x1B
_0x1D:
;     332       {                                 
;     333        // OK, wir sollten uns nun also angesprochen fhlen und den Arsch vom Sofa erheben.......
;     334        
;     335        // Warten auf Kommando
;     336        while (!(USR & 0x80)) 
_0x1E:
	RCALL SUBOPT_0x1
	BRNE _0x1F
;     337        {                               
;     338        }	
	RJMP _0x1E
_0x1F:
;     339        Kommando=UDR;
	IN   R4,12
;     340                                                             
;     341        // Hier gelandet ist also der Slave korrekt angesprochen und das Kommando ist auch 
;     342        // schon rbergekommen
;     343        
;     344        // send_acknowledge ();
;     345                 
;     346        // Jetzt kann mit der Dekodierung begonnen werden
;     347   
;     348   	   switch (Kommando)
	MOV  R30,R4
;     349        {              
;     350         
;     351         case command_switch:           // Lampen direkt ansteuern
	__EQB1NJS 0x22,1
;     352         	 {      
;     353                 // Warten auf das nchste Zeichen
;     354      		   while (!(USR & 0x80)) 
_0x23:
	RCALL SUBOPT_0x1
	BRNE _0x24
;     355        		    {                               
;     356        		    }	
	RJMP _0x23
_0x24:
;     357        		  Datum=UDR;      // Lampenwert
	IN   R5,12
;     358        		        		                     		  
;     359        		  // Wert an Port B ausgeben  
;     360        		  PORTB=Datum;
	OUT  0x18,R5
;     361        		  
;     362         	  send_acknowledge (0);		// Aknowledge rauschieben
	RCALL SUBOPT_0x2
;     363         	  break;
	RJMP _0x21
;     364         	 }
;     365         
;     366         case command_sensor:          		// Sensorsignal auswerten
_0x22:
	__EQB1NJS 0x25,2
;     367         	 {                                                   
;     368         	         	                               		  
;     369         	  send_acknowledge (1);			// Aknowledge rauschieben mit der Sensorinformation
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _send_acknowledge
;     370         	  break;
	RJMP _0x21
;     371         	 }
;     372 
;     373         	       	
;     374         case command_ident:				// Gert identifizieren
_0x25:
	__EQB1NJS 0x21,4
;     375 			 {                          
;     376 			  send_acknowledge (0);		// Aknowledge rauschieben
	RCALL SUBOPT_0x2
;     377         	  break;
;     378        		 }
;     379 
;     380    			 
;     381        } // Von Switch 
_0x21:
;     382        
;     383        } // Von gltiger Slaveadresse mit 9. Datenbit gesetzt
;     384        
;     385       };
_0x1B:
	RJMP _0x17
_0x18:
;     386 }
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	CLR  R30
	ST   -Y,R30
	RJMP _send_acknowledge

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__MULB12U:
	MOV  R0,R26
	SUB  R26,R26
	LDI  R27,9
	RJMP __MULB12U1
__MULB12U3:
	BRCC __MULB12U2
	ADD  R26,R0
__MULB12U2:
	LSR  R26
__MULB12U1:
	ROR  R30
	DEC  R27
	BRNE __MULB12U3
	RET

__CPW01:
	CLR  R0
	CP   R0,R30
	CPC  R0,R31
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

	.ORG 0

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP _timer0_ovf_isr
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
