;CodeVisionAVR C Compiler V1.0.1.4b Evaluation
;(C) Copyright 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
;http://infotech.ir.ro
;e-mail:dhptechn@ir.ro , hpinfotech@mail.com

;Chip type           : AT90S2313
;Clock frequency     : 10,000000 MHz
;Memory model        : Tiny
;Optimize for        : Size
;Internal SRAM size  : 128
;External SRAM size  : 0
;Data Stack size     : 32
;Promote char to int : No
;char is unsigned    : Yes
;Automatic register allocation : On
;Use AVR Studio Terminal I/O   : No

	.DEVICE AT90S2313
	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU UBRR=0x9
	.EQU UCR=0xA
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __JMPZ
	BRNE __FALSE
	RJMP _@0
__FALSE:
	.ENDM

	.MACRO __JMPNZ
	BREQ __FALSE
	RJMP _@0
__FALSE:
	.ENDM

	.MACRO __EQB10
	TST  R30
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB10
	CPI  R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB10
	CLR  R0
	CP   R0,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB10
	CLR  R0
	CP   R0,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB10
	CPI  R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB10
	TST  R30
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW10
	SBIW R30,0
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW10
	SBIW R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW10
	RCALL __CPW01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW10
	RCALL __CPW01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW10
	SBIW R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW10
	SBIW R30,0
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD10
	RCALL __CPD10
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED10
	RCALL __CPD10
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD10
	RCALL __CPD01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED10
	RCALL __CPD01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD10
	RCALL __CPD10
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED10
	RCALL __CPD10
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB12J
	CP   R30,R26
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB12J
	CP   R30,R26
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12J
	CP   R30,R26
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12J
	CP   R26,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12J
	CP   R26,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12J
	CP   R30,R26
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12UJ
	CP   R30,R26
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12UJ
	CP   R26,R30
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12UJ
	CP   R26,R30
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12UJ
	CP   R30,R26
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW12J
	CP   R30,R26
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW12J
	CP   R30,R26
	CPC  R31,R27
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12J
	CP   R30,R26
	CPC  R31,R27
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12J
	CP   R26,R30
	CPC  R27,R31
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12J
	CP   R26,R30
	CPC  R27,R31
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12J
	CP   R30,R26
	CPC  R31,R27
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD12J
	RCALL __CPD12
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED12J
	RCALL __CPD12
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12J
	RCALL __CPD12
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12J
	RCALL __CPD21
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12J
	RCALL __CPD21
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12J
	RCALL __CPD12
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12UJ
	RCALL __CPD12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12UJ
	RCALL __CPD21
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12UJ
	RCALL __CPD21
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12UJ
	RCALL __CPD12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCS __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEF12J
	RCALL __CMPF12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTF12J
	RCALL __CMPF12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCC __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB1NJ
	CPI  R30,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB1NJ
	CPI  R30,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB2NJ
	CPI  R26,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB2NJ
	CPI  R26,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEBN1J
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTBN1J
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEBN1UJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTBN1UJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NJ
	CPI  R26,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NJ
	CPI  R26,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NUJ
	CPI  R26,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NUJ
	CPI  R26,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __BITSREG0
	BRBC @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __BITSREG1
	BRBS @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBR0
	TST  R@0
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR0
	TST  R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR0
	CLR  R0
	CP   R0,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR0
	CLR  R0
	CP   R0,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR0
	TST  R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBR0
	TST  R@0
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBRRJ
	CP   R@0,R@1
	BREQ __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __NEBRRJ
	CP   R@0,R@1
	BRNE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRJ
	CP   R@0,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRJ
	CP   R@1,R@0
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRJ
	CP   R@1,R@0
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRJ
	CP   R@0,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRUJ
	CP   R@0,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRUJ
	CP   R@1,R@0
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRUJ
	CP   R@1,R@0
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRUJ
	CP   R@0,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQW1NJ
	LDI  R27,HIGH(@1)
	CPI  R30,LOW(@1)
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __NEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEB1RJ
	CP   R30,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RJ
	CP   R@0,R30
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RJ
	CP   R@0,R30
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RJ
	CP   R30,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEB1RUJ
	CP   R30,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RUJ
	CP   R@0,R30
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RUJ
	CP   R@0,R30
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RUJ
	CP   R30,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2J
	CP   R@0,R26
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2J
	CP   R26,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2J
	CP   R26,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2J
	CP   R@0,R26
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2UJ
	CP   R@0,R26
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2UJ
	CP   R26,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2UJ
	CP   R26,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2UJ
	CP   R@0,R26
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQBRNJ
	CPI  R@0,LOW(@2)
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBRNJ
	CPI  R@0,LOW(@2)
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __TESTSREG
	LDI  R30,1
	BRBS @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __NTESTSREG
	LDI  R30,1
	BRBC @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __EQB1NJS
	CPI  R30,LOW(@1)
	BRNE _@0
	.ENDM

	.MACRO __EQB2NJS
	CPI  R26,LOW(@1)
	BRNE _@0
	.ENDM

	.MACRO __NEB1NJS
	CPI  R30,LOW(@1)
	BREQ _@0
	.ENDM

	.MACRO __NEB2NJS
	CPI  R26,LOW(@1)
	BREQ _@0
	.ENDM

	.MACRO __LEBN1JS
	CPI  R30,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __LEBN1UJS
	CPI  R30,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __GTBN1JS
	CPI  R30,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __GTBN1UJS
	CPI  R30,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __GEB1NJS
	CPI  R30,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __GEB2NJS
	CPI  R26,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __GEB1NUJS
	CPI  R30,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __GEB2NUJS
	CPI  R26,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __LTB1NJS
	CPI  R30,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __LTB2NJS
	CPI  R26,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __LTB1NUJS
	CPI  R30,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __LTB2NUJS
	CPI  R26,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __EQBR0S
	TST  R@0
	BRNE _@1
	.ENDM

	.MACRO __GEBR0S
	TST  R@0
	BRLT _@1
	.ENDM

	.MACRO __GTBR0S
	CLR  R0
	CP   R0,R@0
	BRGE _@1
	.ENDM

	.MACRO __LEBR0S
	CLR  R0
	CP   R0,R@0
	BRLT _@1
	.ENDM

	.MACRO __LTBR0S
	TST  R@0
	BRGE _@1
	.ENDM

	.MACRO __NEBR0S
	TST  R@0
	BREQ _@1
	.ENDM

	.MACRO __EQBRRJS
	CP   R@0,R@1
	BRNE _@2
	.ENDM

	.MACRO __NEBRRJS
	CP   R@0,R@1
	BREQ _@2
	.ENDM

	.MACRO __LEBRRJS
	CP   R@0,R@1
	BRLT _@2
	.ENDM

	.MACRO __GEBRRJS
	CP   R@1,R@0
	BRLT _@2
	.ENDM

	.MACRO __LTBRRJS
	CP   R@1,R@0
	BRGE _@2
	.ENDM

	.MACRO __GTBRRJS
	CP   R@0,R@1
	BRGE _@2
	.ENDM

	.MACRO __LEBRRUJS
	CP   R@0,R@1
	BRLO _@2
	.ENDM

	.MACRO __GEBRRUJS
	CP   R@1,R@0
	BRLO _@2
	.ENDM

	.MACRO __LTBRRUJS
	CP   R@1,R@0
	BRSH _@2
	.ENDM

	.MACRO __GTBRRUJS
	CP   R@0,R@1
	BRSH _@2
	.ENDM

	.MACRO __EQW1NJS
	LDI  R27,HIGH(@1)
	CPI  R30,LOW(@1)
	CPC  R31,R27
	BRNE _@0
	.ENDM

	.MACRO __EQWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE _@4
	.ENDM

	.MACRO __NEWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ _@4
	.ENDM

	.MACRO __LEWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT _@4
	.ENDM

	.MACRO __GEWRRJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT _@4
	.ENDM

	.MACRO __LTWRRJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE _@4
	.ENDM

	.MACRO __GTWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE _@4
	.ENDM

	.MACRO __LEWRRUJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO _@4
	.ENDM

	.MACRO __GEWRRUJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO _@4
	.ENDM

	.MACRO __LTWRRUJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH _@4
	.ENDM

	.MACRO __GTWRRUJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH _@4
	.ENDM

	.MACRO __EQBRNJS
	CPI  R@0,LOW(@2)
	BRNE _@1
	.ENDM

	.MACRO __NEBRNJS
	CPI  R@0,LOW(@2)
	BREQ _@1
	.ENDM

	.MACRO __GEBRNJS
	CPI  R@0,LOW(@2)
	BRLT _@1
	.ENDM

	.MACRO __LTBRNJS
	CPI  R@0,LOW(@2)
	BRGE _@1
	.ENDM

	.MACRO __GEBRNUJS
	CPI  R@0,LOW(@2)
	BRLO _@1
	.ENDM

	.MACRO __LTBRNUJS
	CPI  R@0,LOW(@2)
	BRSH _@1
	.ENDM

	.MACRO __LEB1RJS
	CP   R30,R@0
	BRLT _@1
	.ENDM

	.MACRO __GEB1RJS
	CP   R@0,R30
	BRLT _@1
	.ENDM

	.MACRO __LTB1RJS
	CP   R@0,R30
	BRGE _@1
	.ENDM

	.MACRO __GTB1RJS
	CP   R30,R@0
	BRGE _@1
	.ENDM

	.MACRO __LEB1RUJS
	CP   R30,R@0
	BRLO _@1
	.ENDM

	.MACRO __GEB1RUJS
	CP   R@0,R30
	BRLO _@1
	.ENDM

	.MACRO __LTB1RUJS
	CP   R@0,R30
	BRSH _@1
	.ENDM

	.MACRO __GTB1RUJS
	CP   R30,R@0
	BRSH _@1
	.ENDM

	.MACRO __LEBR2JS
	CP   R@0,R26
	BRLT _@1
	.ENDM

	.MACRO __GEBR2JS
	CP   R26,R@0
	BRLT _@1
	.ENDM

	.MACRO __LTBR2JS
	CP   R26,R@0
	BRGE _@1
	.ENDM

	.MACRO __GTBR2JS
	CP   R@0,R26
	BRGE _@1
	.ENDM

	.MACRO __LEBR2UJS
	CP   R@0,R26
	BRLO _@1
	.ENDM

	.MACRO __GEBR2UJS
	CP   R26,R@0
	BRLO _@1
	.ENDM

	.MACRO __LTBR2UJS
	CP   R26,R@0
	BRSH _@1
	.ENDM

	.MACRO __GTBR2UJS
	CP   R@0,R26
	BRSH _@1
	.ENDM

	.MACRO __LEW1RJS
	CP   R30,R@0
	CPC  R31,R@1
	BRLT _@2
	.ENDM

	.MACRO __GEW1RJS
	CP   R@0,R30
	CPC  R@1,R31
	BRLT _@2
	.ENDM

	.MACRO __LTW1RJS
	CP   R@0,R30
	CPC  R@1,R31
	BRGE _@2
	.ENDM

	.MACRO __GTW1RJS
	CP   R30,R@0
	CPC  R31,R@1
	BRGE _@2
	.ENDM

	.MACRO __LEW1RUJS
	CP   R30,R@0
	CPC  R31,R@1
	BRLO _@2
	.ENDM

	.MACRO __GEW1RUJS
	CP   R@0,R30
	CPC  R@1,R31
	BRLO _@2
	.ENDM

	.MACRO __LTW1RUJS
	CP   R@0,R30
	CPC  R@1,R31
	BRSH _@2
	.ENDM

	.MACRO __GTW1RUJS
	CP   R30,R@0
	CPC  R31,R@1
	BRSH _@2
	.ENDM

	.MACRO __LEWR2JS
	CP   R@0,R26
	CPC  R@1,R27
	BRLT _@2
	.ENDM

	.MACRO __GEWR2JS
	CP   R26,R@0
	CPC  R27,R@1
	BRLT _@2
	.ENDM

	.MACRO __LTWR2JS
	CP   R26,R@0
	CPC  R27,R@1
	BRGE _@2
	.ENDM

	.MACRO __GTWR2JS
	CP   R@0,R26
	CPC  R@1,R27
	BRGE _@2
	.ENDM

	.MACRO __LEWR2UJS
	CP   R@0,R26
	CPC  R@1,R27
	BRLO _@2
	.ENDM

	.MACRO __GEWR2UJS
	CP   R26,R@0
	CPC  R27,R@1
	BRLO _@2
	.ENDM

	.MACRO __LTWR2UJS
	CP   R26,R@0
	CPC  R27,R@1
	BRSH _@2
	.ENDM

	.MACRO __GTWR2UJS
	CP   R@0,R26
	CPC  R@1,R27
	BRSH _@2
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.CSEG
	.ORG 0x0B

	.INCLUDE "display.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31
	OUT  MCUCR,R30

;CLEAR R2-R15
	LDI  R24,14
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	MOV  R1,R0
	ADIW R30,1
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	MOV  R26,R0
	ADIW R30,1
	LPM
	MOV  R27,R0
	ADIW R30,1
	LPM
	MOV  R24,R0
	ADIW R30,1
	LPM
	MOV  R25,R0
	ADIW R30,1
__GLOBAL_INI_LOOP:
	LPM
	ST   X+,R0
	ADIW R30,1
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x7F)

	RJMP _main

	.ESEG
	.ORG 1

	.DSEG
	.ORG 0x80
;       1 /*
;       2 
;       3 Project : RS485-Display
;       4 
;       5 Chip type        : AT90S2313
;       6 Clock frequency  : 10,000000 MHz
;       7 Memory model     : Tiny
;       8 Internal RAM size: 128
;       9 External RAM size: 0
;      10 Data Stack size  : 32
;      11 ***************************************/
;      12 
;      13 #include <90s2313.h>
;      14 // CodeVisionAVR C Compiler
;      15 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      16 
;      17 // I/O registers definitions for the AT90S2313
;      18 
;      19 #ifndef _90S2313_INCLUDED_
;      20 #define _90S2313_INCLUDED_
;      21 
;      22 #pragma used+
;      23 sfrb ACSR=8;
;      24 sfrb UBRR=9;
;      25 sfrb UCR=0xa;
;      26 sfrb USR=0xb;
;      27 sfrb UDR=0xc;
;      28 sfrb PIND=0x10;
;      29 sfrb DDRD=0x11;
;      30 sfrb PORTD=0x12;
;      31 sfrb PINB=0x16;
;      32 sfrb DDRB=0x17;
;      33 sfrb PORTB=0x18;
;      34 sfrb EECR=0x1c;
;      35 sfrb EEDR=0x1d;
;      36 sfrb EEAR=0x1e;
;      37 sfrb WDTCR=0x21;
;      38 sfrb ICR1L=0x24;
;      39 sfrb ICR1H=0x25;
;      40 sfrw ICR1=0x24;   // 16 bit access
;      41 sfrb OCR1L=0x2a;
;      42 sfrb OCR1H=0x2b;
;      43 sfrw OCR1=0x2a;   // 16 bit access
;      44 sfrb TCNT1L=0x2c;
;      45 sfrb TCNT1H=0x2d;
;      46 sfrw TCNT1=0x2c;  // 16 bit access
;      47 sfrb TCCR1B=0x2e;
;      48 sfrb TCCR1A=0x2f;
;      49 sfrb TCNT0=0x32;
;      50 sfrb TCCR0=0x33;
;      51 sfrb MCUSR=0x34;
;      52 sfrb MCUCR=0x35;
;      53 sfrb TIFR=0x38;
;      54 sfrb TIMSK=0x39;
;      55 sfrb GIFR=0x3a;
;      56 sfrb GIMSK=0x3b;
;      57 sfrb SPL=0x3d;
;      58 sfrb SREG=0x3f;
;      59 #pragma used-
;      60 
;      61 #define OCR1AL OCR1L
;      62 #define OCR1AH OCR1H
;      63 
;      64 // Interrupt vectors definitions
;      65 
;      66 #define EXT_INT0 2
;      67 #define EXT_INT1 3
;      68 #define TIM1_CAPT 4
;      69 #define TIM1_COMP 5
;      70 #define TIM1_OVF 6
;      71 #define TIM0_OVF 7
;      72 #define UART_RXC 8
;      73 #define UART_DRE 9
;      74 #define UART_TXC 10
;      75 #define ANA_COMP 11
;      76 
;      77 #endif
;      78 
;      79 
;      80 // Standard Input/Output functions
;      81 #include <stdio.h>
;      82 // CodeVisionAVR C Compiler
;      83 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      84 
;      85 // Prototypes for standard I/O functions
;      86 
;      87 #ifndef _STDIO_INCLUDED_
;      88 #define _STDIO_INCLUDED_
;      89 
;      90 #ifndef NULL
;      91 #define NULL 0
;      92 #endif
;      93 
;      94 #pragma used+
;      95 
;      96 #pragma warn-
;      97 #ifndef _DEBUG_TERMINAL_IO_
;      98 #ifndef _ALTERNATE_GETCHAR_
;      99 char getchar(void)
;     100 {

	.CSEG
_getchar:
;     101 #asm
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
;     105 #endasm
;     106 }
	RET
;     107 #endif
;     108 
;     109 #ifndef _ALTERNATE_PUTCHAR_
;     110 void putchar(char c)
;     111 {
_putchar:
;     112 #asm
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
;     117 #endasm
;     118 }
	RJMP _0x3F
;     119 #endif
;     120 #else
;     121 // Used for AVR Studio Terminal I/O
;     122 // DON'T CHANGE!
;     123 char getchar(void)
;     124 {
;     125 #asm
;     126      push  r16
;     127      push  r17
;     128 __getchar0:
;     129      rcall __c_getchar
;     130      cpi   r17,0xff
;     131      breq  __getchar0
;     132      mov   r30,r16
;     133      pop   r17
;     134      pop   r16
;     135 #endasm
;     136 }
;     137 
;     138 void putchar(char c)
;     139 {
;     140 #asm
;     141     mov   r30,r16
;     142     ld    r16,y
;     143     rcall __c_putchar
;     144     mov   r16,r30
;     145 #endasm
;     146 }
;     147 
;     148 void _c_getchar(void)
;     149 {
;     150 }
;     151 
;     152 void _c_putchar(void)
;     153 {
;     154 }
;     155 #endif
;     156 
;     157 #ifdef _WARNINGS_ON_
;     158 #pragma warn+
;     159 #endif
;     160 
;     161 void puts(char *str);
;     162 void putsf(char flash *str);
;     163 
;     164 #ifdef _MODEL_TINY_
;     165 char *gets(char *str,unsigned char len);
;     166 #endif
;     167 
;     168 #ifdef _MODEL_SMALL_
;     169 char *gets(char *str,unsigned int len);
;     170 #endif
;     171 
;     172 #pragma parptr+
;     173 void printf(char flash *fmtstr);
;     174 void sprintf(char *str, char flash *fmtstr);
;     175 char scanf(char flash *fmtstr);
;     176 char sscanf(char *str,char flash *fmtstr);
;     177 #pragma parptr-
;     178 
;     179 #pragma used-
;     180 
;     181 #endif
;     182 
;     183 
;     184 // Declare your global variables here     
;     185                      
;     186 // Belegung der Hardware
;     187 
;     188 // PB0 : D0 (out)
;     189 // ......
;     190 // PB7 : D7 (out)
;     191 
;     192 // PD0 : RxD (In)
;     193 // PD1 : TxD (Out)
;     194 // PD2 : RS (Out)
;     195 // PD3 : n.c.
;     196 // PD4 : RE (Out)
;     197 // PD5 : EN (Out)
;     198 // PD6 : RW (Out)
;     199  
;     200 // Konstantendefinitionen
;     201 #define Slaveadresse 		0xB0   	// Eigene Adresse, hier 176d	
;     202 #define command_get_char 	0x01	// Nachfolgendes Zeichen ausgeben	
;     203 #define command_get_com 	0x02	// Nachfolgendes Kommando ausfhren
;     204 #define command_ident		0x04	// Gert Identifizieren    
;     205 #define command_light		0x05	// Licht an oder aus	
;     206 
;     207 char Kommando, Datum;		// Die empfangenen Daten, welche zum Display geschoben werden
;     208 char zeile;			// Welcher Controller soll angesprochen werden ?
;     209 char temp;			// Zwischenspeicher                 
;     210 char zaehler;	
;     211 
;     212 // RS=High : Daten senden, PortD,2
;     213 // RS=Low  : Instruction senden
;     214 
;     215 // RW=Low : Schreibzugriff auf Display, PortD,6
;     216 // RW=High : Lesezugriff auf Display      
;     217        
;     218 // Erzeugt High-Impuls auf Enable
;     219 // 0 fr Zeile 1 & 3, 1 fr Zeile 2 & 4
;     220 void toggle_enable (void)
;     221 {             
_toggle_enable:
;     222  short int inner,outer; // Zhlvariablen
;     223                    
;     224  if (zeile==0) PORTB|=1;		// Enbale Controller 0 auf High
	RCALL __SAVELOCR4
;	inner -> R16,R17
;	outer -> R18,R19
	__EQBR0S 6,11
	SBI  0x18,0
;     225 	else PORTB|=2;		// Enbale Controller 1 auf High 
	RJMP _0xC
_0xB:
	SBI  0x18,1
_0xC:
;     226 
;     227  // ca. 1us Pause
;     228  for (inner=2;inner>0;inner--) 
	__GETWRN 16,17,2
_0xD:
	__GETW1R 16,17
	RCALL __CPW01
	BRGE _0xF
;     229  { 
;     230   outer=inner;
	__MOVEWRR 18,19,16,17
;     231  };				
_0xE:
	__SUBWRN 16,17,1
	RJMP _0xD
_0xF:
;     232  
;     233  PORTB&=(255-3); // Alle Enables auf Low
	IN   R30,0x18
	ANDI R30,LOW(0xFC)
	OUT  0x18,R30
;     234 } // End of toggle_enable
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;     235                                                                          
;     236 // Ganz kurze Pause machen, ca. 10 ms bei 10 Mhz
;     237 void delay (short int dauer)
;     238 {                         
_delay:
;     239 	int inner,outer;		// Zhlvariablen
;     240 	
;     241 	for (outer=dauer;outer>0;outer--)  // Outer*0.7ms bei 8 Mhz
	RCALL __SAVELOCR4
;	dauer -> Y+4
;	inner -> R16,R17
;	outer -> R18,R19
	__GETWRS 18,19,4
_0x11:
	__GETW1R 18,19
	RCALL __CPW01
	BRGE _0x13
;     242 	 for (inner=255;inner>0;inner--);
	__GETWRN 16,17,255
_0x14:
	__GETW1R 16,17
	RCALL __CPW01
	BRGE _0x16
_0x15:
	__SUBWRN 16,17,1
	RJMP _0x14
_0x16:
_0x12:
	__SUBWRN 18,19,1
	RJMP _0x11
_0x13:
;     243 	
;     244 } // end of delay 
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
;     245 
;     246 // Sendet ein Zeichen als Nibble zum Display (Zeichen bergeben in "Datum", Zeile in "Zeile"
;     247 void transmit (void)
;     248  {                
_transmit:
;     249  	temp=(Datum & 240);     // Zwischenspeichern, obere 4 Bits ausmaskieren
	MOV  R30,R5
	ANDI R30,LOW(0xF0)
	MOV  R7,R30
;     250         PORTB=temp;     	 // Display-Kommando anlegen
	OUT  0x18,R7
;     251         toggle_enable ();   	 // Und rein damit
	RCALL _toggle_enable
;     252         temp=(Datum & 15);	 // Zwischenspeichern, untere 4 Bits ausmaskieren
	MOV  R30,R5
	ANDI R30,LOW(0xF)
	MOV  R7,R30
;     253         temp=(temp<<4);		 // Bits nach oben schieben
	SWAP R7
	LDI  R30,0xF0
	AND  R7,R30
;     254         PORTB=temp;     	 // Display-Kommando anlegen
	OUT  0x18,R7
;     255         toggle_enable ();   	 // Und rein damit
	RCALL _toggle_enable
;     256   }
	RET
;     257 
;     258 
;     259 // Display-Controller initialisieren (Nibble-Mode), je nach "Zeile"
;     260 void display_init (void)
;     261 {     
_display_init:
;     262 	PORTB=0x00; // Alles aus
	RCALL SUBOPT_0x0
;     263 	PORTD=0x00; // Alles aus
	RCALL SUBOPT_0x1
;     264 	
;     265 	PORTB=48;    // 00110000
	LDI  R30,LOW(48)
	RCALL SUBOPT_0x2
;     266 	toggle_enable ();
;     267   	delay (10);
	RCALL SUBOPT_0x3
;     268     	toggle_enable ();
;     269   	delay (10);
	RCALL SUBOPT_0x3
;     270     	toggle_enable ();
;     271   	delay (10);
	RCALL SUBOPT_0x4
;     272         
;     273         PORTB=32;    // 00100000 Umschalten auf Nibble-Mode
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x2
;     274 	toggle_enable ();
;     275                                                            
;     276  	// Ab jetzt nur noch Nibble-Kommunikation, obere 4 Bits zuerst
;     277                                    
;     278     	// Font einstellen 5*11 dots
;     279     	Datum=44;
	LDI  R30,LOW(44)
	RCALL SUBOPT_0x5
;     280     	transmit ();
;     281 	delay (10);
;     282    
;     283    	// Display off, cursor off, blink off                             
;     284    	Datum=8;
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x5
;     285    	transmit ();
;     286 	delay (10);
;     287    
;     288    	// Clear Screen, Home
;     289     	Datum=1;
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x5
;     290     	transmit ();
;     291 	delay (10);
;     292                         
;     293 	// Increment Cursor, dont shift
;     294 	Datum=6;
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x5
;     295 	transmit ();
;     296     	delay (10);
;     297          
;     298    	// Display wieder ein, Cursor aus
;     299 	Datum=12;
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x5
;     300 	transmit ();
;     301 	delay (10);
;     302    
;     303    
;     304 }//end of display_init
	RET
;     305                                          
;     306 // Sendet ein Acknowledge
;     307 void send_acknowledge (void)
;     308 {                     
_send_acknowledge:
;     309 	// Transmitter auf senden schalten
;     310 	PORTD|=16; // PD 4 auf High ziehen
	SBI  0x12,4
;     311 	     
;     312 	// Kurze Pause fr den Bus
;     313 	delay (18);
	RCALL SUBOPT_0x6
;     314 	
;     315     //  TXC auf Null setzen durch berschreiben mit 1
;     316     USR|=64;
	SBI  0xB,6
;     317     
;     318    	// Slaveadresse senden
;     319    	UDR=Slaveadresse;
	LDI  R30,LOW(176)
	OUT  0xC,R30
;     320 
;     321     // Warten, bis das Zeichen raus ist....
;     322     delay (18);
	RCALL SUBOPT_0x6
;     323     
;     324 	//  TXC auf Null setzen durch berschreiben mit 1
;     325     USR|=64;
	SBI  0xB,6
;     326     
;     327 	// Kommando hinterher schieben
;     328 	UDR=Kommando;
	OUT  0xC,R4
;     329 	
;     330 	// Hier noch warten, bis die Bytes raus sind
;     331     // Warten, bis das Zeichen raus ist....
;     332     delay (18);
	RCALL SUBOPT_0x6
;     333      
;     334 	// Transmitter wieder abschalten
;     335 	PORTD&=239; // PD 4 auf Low ziehen
	CBI  0x12,4
;     336 	 
;     337 }
	RET
;     338                      
;     339 //EEPROM  read, returns data byte       
;     340 char read_eeprom (char address)
;     341 {  
_read_eeprom:
;     342    while (EECR & 0x02);       //wait for EEWE==0
_0x1B:
	IN   R30,0x1C
	ANDI R30,LOW(0x2)
	BREQ _0x1C
	RJMP _0x1B
_0x1C:
;     343    EEAR = address;            //write address to (EEAR)
	LD   R30,Y
	OUT  0x1E,R30
;     344    EECR = 0x01;               //set EERE=1 (EECR.0)
	LDI  R30,LOW(1)
	OUT  0x1C,R30
;     345    return (EEDR);
	IN   R30,0x1D
_0x3F:
	ADIW R28,1
	RET
;     346 }//end function
;     347        
;     348 //---------------------------------------------
;     349 // Hauptprogramm                              
;     350 //---------------------------------------------
;     351 void main(void)
;     352 {
_main:
;     353 // Declare your local variables here
;     354 
;     355 // Input/Output Ports initialization
;     356 // Port B
;     357 DDRB=0xFF;    // Alles Output
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     358 PORTB=0x00;
	RCALL SUBOPT_0x0
;     359 
;     360 // Port D
;     361 DDRD=0x7C; // 01111100, RXD, TXD ausgenommen
	LDI  R30,LOW(124)
	OUT  0x11,R30
;     362 PORTD=0x00;
	RCALL SUBOPT_0x1
;     363 
;     364 // Timer/Counter 0 initialization
;     365 // Clock source: System Clock
;     366 // Clock value: Timer 0 Stopped
;     367 // Mode: Output Compare
;     368 // OC0 output: Disconnected
;     369 TCCR0=0x00;
	CLR  R30
	OUT  0x33,R30
;     370 TCNT0=0x00;
	OUT  0x32,R30
;     371 
;     372 // Timer/Counter 1 initialization
;     373 // Clock source: System Clock
;     374 // Clock value: Timer 1 Stopped
;     375 // Mode: Output Compare
;     376 // OC1 output: Discon.
;     377 // Noise Canceler: Off
;     378 // Input Capture on Falling Edge
;     379 TCCR1A=0x00;
	OUT  0x2F,R30
;     380 TCCR1B=0x00;
	OUT  0x2E,R30
;     381 TCNT1H=0x00;
	OUT  0x2D,R30
;     382 TCNT1L=0x00;
	OUT  0x2C,R30
;     383 OCR1H=0x00;
	OUT  0x2B,R30
;     384 OCR1L=0x00;
	OUT  0x2A,R30
;     385 
;     386 // UART initialization
;     387 // Communication Parameters: 9 Data, 1 Stop, No Parity
;     388 // UART Receiver: On
;     389 // UART Transmitter: On
;     390 UCR=0x1C;
	LDI  R30,LOW(28)
	OUT  0xA,R30
;     391 // UART Baud rate: 9600 @ 10 MHz
;     392 UBRR=0x40;  
	LDI  R30,LOW(64)
	OUT  0x9,R30
;     393 
;     394 // Analog Comparator initialization
;     395 // Analog Comparator: Off
;     396 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     397 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     398                   
;     399 // Display initialisieren
;     400 zeile=0;
	CLR  R6
;     401 display_init ();	// Ungerade Zeilen
	RCALL _display_init
;     402 zeile=1;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     403 display_init ();       // Gerade Zeilen
	RCALL _display_init
;     404                                      
;     405  
;     406 // Starttext ausgeben
;     407 zeile=0;			// Controller 0 ansprechen
	CLR  R6
;     408 
;     409 // Cursor auf Anfg zweite Zeile setzen
;     410 PORTD&=0xFB;		// PortD,2 (RS) auf Low ziehen
	CBI  0x12,2
;     411 Datum=(64+128);
	LDI  R30,LOW(192)
	MOV  R5,R30
;     412 transmit ();		// Und raus damit
	RCALL _transmit
;     413 
;     414 PORTD|=4;			// PortD,2 (RS) auf High ziehen
	SBI  0x12,2
;     415 for (zaehler=1;zaehler<30;zaehler++)
	LDI  R30,LOW(1)
	MOV  R8,R30
_0x1E:
	LDI  R30,LOW(30)
	__LTB1RUJS 8,32
;     416  {
;     417   Datum=read_eeprom (zaehler);
	ST   -Y,R8
	RCALL _read_eeprom
	MOV  R5,R30
;     418   // Datum=65+zaehler;
;     419   delay (10);	
	RCALL SUBOPT_0x4
;     420   transmit ();
	RCALL _transmit
;     421  }
_0x1F:
	INC  R8
	RJMP _0x1E
_0x20:
;     422 
;     423 
;     424 while (1)
_0x21:
;     425       {
;     426       // Warten auf empfangenes Zeichen 
;     427       while (!(USR & 0x80)) 
_0x23:
	RCALL SUBOPT_0x7
	BRNE _0x24
;     428       {                                 
;     429       }
	RJMP _0x23
_0x24:
;     430       // Ist das 9. Datenbit gesetzt und die Slaveadresse gltig ?
;     431       if ( (UDR==Slaveadresse) && ( UCR & 0x02) )
	IN   R30,0xC
	__EQB1NJS 0x26,176
	IN   R30,0xA
	ANDI R30,LOW(0x2)
	BREQ _0x26
	RJMP _0x27
_0x26:
	RJMP _0x25
_0x27:
;     432       {                                 
;     433        // OK, wir sollten uns nun also angesprochen fhlen und den Arsch vom Sofa erheben.......
;     434       
;     435        // Als nchstes werden noch 2 Bytes folgen, die die Daten enthalten
;     436        
;     437        // Warten auf empfangenes Zeichen 
;     438       while (!(USR & 0x80)) 
_0x28:
	RCALL SUBOPT_0x7
	BRNE _0x29
;     439       {                               
;     440       }	
	RJMP _0x28
_0x29:
;     441       Kommando=UDR;
	IN   R4,12
;     442        
;     443       // Hier gelandet ist also der Slave korrekt angesprochen und das Kommando ist auch 
;     444        // schon rbergekommen
;     445        
;     446        // send_acknowledge ();
;     447                 
;     448        // Jetzt kann mit der Dekodierung begonnen werden
;     449        switch (Kommando)
	MOV  R30,R4
;     450        {              
;     451           
;     452         case command_ident:             // Slave identifizieren
	__EQB1NJS 0x2C,4
;     453         	 {      
;     454         	  send_acknowledge ();		// Aknowledge rauschieben
	RCALL _send_acknowledge
;     455         	  break;
	RJMP _0x2B
;     456         	 }
;     457       
;     458          case command_get_char:			// Nachfolgendes Zeichen ausgeben	
_0x2C:
	__EQB1NJS 0x2D,1
;     459         	 {            
;     460         	 
;     461         	  // Warten auf das nchste Zeichen, welcher Controller soll angesprochen werden
;     462      		   while (!(USR & 0x80)) 
_0x2E:
	RCALL SUBOPT_0x7
	BRNE _0x2F
;     463        		    {                               
;     464        		    }	
	RJMP _0x2E
_0x2F:
;     465                	   zeile=UDR; 
	IN   R6,12
;     466         	   
;     467         	 // Die Zeichen kommen jetzt als Null-terminierter String rber
;     468         	 Datum=1;
	LDI  R30,LOW(1)
	MOV  R5,R30
;     469         	 while (Datum!=0) // Abbruchkriterium setzen
_0x30:
	__NEBR0S 5,49
;     470         	 {
;     471                    // Warten auf das nchste Zeichen
;     472      		   while (!(USR & 0x80)) 
_0x32:
	RCALL SUBOPT_0x7
	BRNE _0x33
;     473        		    {                               
;     474        		    }	
	RJMP _0x32
_0x33:
;     475                    Datum=UDR; 
	IN   R5,12
;     476                   
;     477               	 if (Datum!=0)  // Auszugebendes Zeichen ?
	__NEBR0S 5,52
;     478               	 {                               
;     479               	  PORTD|=4;			// PortD,2 (RS) auf High ziehen
	SBI  0x12,2
;     480  		  transmit ();			// Und raus damit           	 
	RCALL _transmit
;     481               	 } // Von if (datum!=0)	
;     482 			              
;     483         	 } // Von While
_0x34:
	RJMP _0x30
_0x31:
;     484         	 
;     485         	  send_acknowledge ();		// Aknowledge rauschieben
	RCALL _send_acknowledge
;     486         	  break;
	RJMP _0x2B
;     487         	 }
;     488 	     
;     489 	     case command_get_com:			// Nachfolgendes Kommando ausfhren
_0x2D:
	__EQB1NJS 0x35,2
;     490         	 {
;     491         	  // Warten auf das nchste Zeichen, welcher Controller soll angesprochen werden
;     492      		   while (!(USR & 0x80)) 
_0x36:
	RCALL SUBOPT_0x7
	BRNE _0x37
;     493        		    {                               
;     494        		    }	
	RJMP _0x36
_0x37:
;     495                	   zeile=UDR; 
	IN   R6,12
;     496                   
;     497                   // Warten auf das nchste Zeichen, das eigentliche Kommando
;     498      		   while (!(USR & 0x80)) 
_0x38:
	RCALL SUBOPT_0x7
	BRNE _0x39
;     499        		    {                               
;     500        		    }	
	RJMP _0x38
_0x39:
;     501                    Datum=UDR; 
	IN   R5,12
;     502                   
;     503                             
;     504               	// Das Kommando ist rber und kann zum Display geschoben werden 
;     505               	PORTD&=0xFB;		// PortD,2 (RS) auf Low ziehen
	CBI  0x12,2
;     506                 transmit ();		// Und raus damit
	RCALL _transmit
;     507                 
;     508               	send_acknowledge ();	 // Aknowledge rauschieben
	RCALL _send_acknowledge
;     509         	 break;
	RJMP _0x2B
;     510               
;     511         	 }
;     512         	 
;     513 		case command_light:			// Licht ein- und ausschalten
_0x35:
	__EQB1NJS 0x2B,5
;     514         	 {
;     515         	  // Warten auf das nchste Zeichen
;     516      		   while (!(USR & 0x80)) 
_0x3B:
	RCALL SUBOPT_0x7
	BRNE _0x3C
;     517        		    {                               
;     518        		    }	
	RJMP _0x3B
_0x3C:
;     519               Datum=UDR; 
	IN   R5,12
;     520                             
;     521               // Ist Datum=0, dann Licht aus, sonst Licht ein
;     522               if (Datum==0) 
	__EQBR0S 5,61
;     523               {           // Licht aus
;     524                 PORTD&=247;  // Bit 3 auf Null
	CBI  0x12,3
;     525               }  else
	RJMP _0x3E
_0x3D:
;     526               
;     527               {           // Licht ein        
;     528               	PORTD|=8;  // Bit 3 auf Eins
	SBI  0x12,3
;     529               };
_0x3E:
;     530               
;     531               send_acknowledge ();		// Aknowledge rauschieben
	RCALL _send_acknowledge
;     532         	  break;
;     533         	 }
;     534         	         	 
;     535        } // Von Switch 
_0x2B:
;     536      
;     537      }
;     538      
;     539      } // Von While (1)
_0x25:
	RJMP _0x21
_0x22:
;     540 }
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	CLR  R30
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	CLR  R30
	OUT  0x12,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	OUT  0x18,R30
	RJMP _toggle_enable

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay
	RJMP _toggle_enable

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	MOV  R5,R30
	RCALL _transmit
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x7:
	IN   R30,0xB
	ANDI R30,LOW(0x80)
	RET

__CPW01:
	CLR  R0
	CP   R0,R30
	CPC  R0,R31
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

	.ORG 0

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
